VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Image Info from File Header"
   ClientHeight    =   3195
   ClientLeft      =   3315
   ClientTop       =   2445
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   Begin VB.CommandButton Command2 
      Caption         =   "View Last Entry in Associated Viewer"
      Height          =   255
      Left            =   720
      TabIndex        =   3
      Top             =   2880
      Width           =   3495
   End
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   120
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox Text1 
      Height          =   1575
      Left            =   240
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   1080
      Width           =   4335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Get Jpg or Gif Image Info"
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   240
      Width           =   2895
   End
   Begin VB.Label Label1 
      Caption         =   "File Name --- Size ----- Width X Height"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   2
      Top             =   720
      Width           =   4095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecute& Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpfile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long)

Dim ImageInfo As BITMAPINFO

Private Type BITMAPINFO
    Width As Long
    Height As Long
End Type
Private Function GetGIFInfo(ByVal FileName As String) As BITMAPINFO
    Dim bChar As Byte
    Dim i As Integer
    Dim dotPos As Integer
    Dim Header As String
    Dim blExit As Boolean
    Dim a As String, b As String
    Dim ImgSize As String
    Dim fnum As Integer
    Dim ImgWidth As Integer
    Dim ImgHeight As Integer

    On Error Resume Next
    fnum = FreeFile
    Open FileName For Binary As #fnum

    ImgSize = LOF(fnum) / 1024

    dotPos = InStr(ImgSize, ",")
    ImgSize = Left(ImgSize, dotPos - 1)

    For i = 0 To 5
        Get #fnum, , bChar
        Header = Header + Chr(bChar)
    Next i

    If Left(Header, 3) <> "GIF" Then
        MsgBox FileName & ": not a GIF file"
        Close #fnum
        Exit Function
        End
    End If

    Get #fnum, , bChar
    a = a + Chr(bChar)
    Get #fnum, , bChar
    a = a + Chr(bChar)

    ImgWidth = CInt(Asc(Left(a, 1)) + 256 * Asc(Right(a, 1)))

    Get #fnum, , bChar
    b = b + Chr(bChar)
    Get #fnum, , bChar
    b = b + Chr(bChar)

    ImgHeight = CInt(Asc(Left(b, 1)) + 256 * Asc(Right(b, 1)))

    Close #fnum

    With ImageInfo
        .Width = ImgWidth
        .Height = ImgHeight
    End With

    GetGIFInfo = ImageInfo
End Function


'Jpg Header Information

Private Function GetJPGInfo(ByVal FileName As String) As BITMAPINFO
    Dim bChar As Byte
    Dim a As Byte, b As Byte
    Dim c As Byte, D As Byte
    Dim E As Byte, f As Byte
    Dim i As Integer
    Dim dotPos As Integer
    Dim Header As String
    Dim blExit As Boolean
    Dim MarkerLen As Long
    Dim ImgSize As String
    Dim fnum As Integer
    Dim ImgWidth As Integer
    Dim ImgHeight As Integer
    On Error Resume Next

    fnum = FreeFile
    Open FileName For Binary As #fnum

    ImgSize = LOF(fnum) / 1024
    dotPos = InStr(ImgSize, ",")
    ImgSize = Left(ImgSize, dotPos)

    Get #fnum, , bChar
    Header = Hex$(bChar)
    Get #fnum, , bChar
    Header = Header & Hex$(bChar)
    If Header <> "FFD8" Then Exit Function

    While Not blExit
        Do Until Hex$(bChar) = "FF"
            Get #fnum, , bChar
        Loop

        Get #fnum, , bChar
        If Hex$(bChar) >= "C0" And _
                Hex$(bChar) <= "C3" Then
            Get #fnum, , bChar
            Get #fnum, , bChar
            Get #fnum, , bChar

            Get #fnum, , bChar
            a = bChar
            Get #fnum, , bChar
            b = bChar
            Get #fnum, , bChar
            c = bChar
            Get #fnum, , bChar
            D = bChar

            ImgHeight = CInt(a * 256 + b)
            ImgWidth = CInt(c * 256 + D)
            blExit = True
        Else
            If Hex$(bChar) = "DA" Then
                blExit = True
            Else
                Get #fnum, , bChar
                E = bChar
                Get #fnum, , bChar
                f = bChar
                MarkerLen = (E * 256 + f) - 2

                Dim marker As String
                marker = String(MarkerLen, vbNullChar)
                Get #fnum, , marker
            End If
        End If
    Wend

    Close #fnum

    With ImageInfo
        .Width = ImgWidth
        .Height = ImgHeight
    End With

    GetJPGInfo = ImageInfo
End Function



Private Sub Command1_Click()
Dim fileSize
Dim suffit As String
Dim dotPos As Integer

    dlgFile.Filter = "Jpg or Gif Files (*.jpg;*.gif)|*.jpg;*.gif" '|Gif Files (*.gif*)|*.gif*"
    dlgFile.Flags = _
        cdlOFNHideReadOnly + _
        cdlOFNFileMustExist + _
        cdlOFNExplorer
    dlgFile.CancelError = True
    dlgFile.InitDir = App.Path
    On Error Resume Next
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error " & Format$(Err.Number) & _
            " selecting file." & vbCrLf & _
            Err.Description
        Exit Sub
    End If

    fileSize = FileLen(dlgFile.FileName)
    If fileSize < 1000 Then
        suffit = " Bytes"
        GoTo showit
    End If
    If fileSize > 1000000 Then
        fileSize = Int(fileSize / 1000000)
        suffit = " Mb"
        GoTo showit
    Else
        fileSize = Int(fileSize / 1000)
        suffit = " Kb"
    End If

    dotPos = InStrRev(dlgFile.FileName, ".jpg")
    If dotPos = Len(dlgFile.FileName) - 3 Then
        GetJPGInfo (dlgFile.FileName)
        GoTo showit
    End If
    dotPos = InStrRev(dlgFile.FileName, ".gif")
    If dotPos = Len(dlgFile.FileName) - 3 Then
        GetGIFInfo (dlgFile.FileName)
        GoTo showit
    Else
        MsgBox "Not valid Jpg or Gif file."
        Exit Sub
    End If
showit:
    Text1.Text = Text1.Text & vbCrLf _
        & dlgFile.FileTitle & "-" & fileSize & suffit _
        & "-" & ImageInfo.Width & "x" & ImageInfo.Height
End Sub

Private Sub Command2_Click()
If dlgFile.FileName = "" Then Exit Sub

Dim lpParameters As String
Dim nShowCom As Long
Dim slashPos As Integer
Dim filePath As String
lpParameters = ""
nShowCom = 1
slashPos = InStrRev(dlgFile.FileName, "\")
filePath = Mid(dlgFile.FileName, 1, slashPos)
Call ShellExecute&(hwnd, "Open", dlgFile.FileName, lpParameters, filePath, nShowCom)

End Sub
